
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Validation_rule_setsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const validation_rule_sets = await db.validation_rule_sets.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
        is_default: data.is_default
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await validation_rule_sets.setTenant( data.tenant || null, {
            transaction,
        });
        
        await validation_rule_sets.setData_entity( data.data_entity || null, {
            transaction,
        });
        
        await validation_rule_sets.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return validation_rule_sets;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const validation_rule_setsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
                is_default: item.is_default
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const validation_rule_sets = await db.validation_rule_sets.bulkCreate(validation_rule_setsData, { transaction });

        // For each item created, replace relation files
        

        return validation_rule_sets;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const validation_rule_sets = await db.validation_rule_sets.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        if (data.is_default !== undefined) updatePayload.is_default = data.is_default;
        
        
        updatePayload.updatedById = currentUser.id;

        await validation_rule_sets.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await validation_rule_sets.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.data_entity !== undefined) {
            await validation_rule_sets.setData_entity(
              
              data.data_entity,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await validation_rule_sets.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return validation_rule_sets;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const validation_rule_sets = await db.validation_rule_sets.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of validation_rule_sets) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of validation_rule_sets) {
                await record.destroy({transaction});
            }
        });


        return validation_rule_sets;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const validation_rule_sets = await db.validation_rule_sets.findByPk(id, options);

        await validation_rule_sets.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await validation_rule_sets.destroy({
            transaction
        });

        return validation_rule_sets;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const validation_rule_sets = await db.validation_rule_sets.findOne(
            { where },
            { transaction },
        );

        if (!validation_rule_sets) {
            return validation_rule_sets;
        }

        const output = validation_rule_sets.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        output.validation_rules_rule_set = await validation_rule_sets.getValidation_rules_rule_set({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await validation_rule_sets.getTenant({
            transaction
        });
        
        
        output.data_entity = await validation_rule_sets.getData_entity({
            transaction
        });
        
        
        output.organizations = await validation_rule_sets.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.data_entities,
        as: 'data_entity',
        
        where: filter.data_entity ? {
          [Op.or]: [
            { id: { [Op.in]: filter.data_entity.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.data_entity.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'validation_rule_sets',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'validation_rule_sets',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            
            if (filter.is_default) {
                where = {
                    ...where,
                is_default: filter.is_default,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.validation_rule_sets.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'validation_rule_sets',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.validation_rule_sets.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

